# Godot 4 Open RPG

![Godot Open RPG banner](media/Open-RPG.png)

OpenRPG is a tool and a demo to create Role Playing Games with turn-based combat.

➡ Follow us on [Twitter](https://twitter.com/NathanGDQuest) and [YouTube](https://www.youtube.com/c/gdquest/) for free game creation tutorials, tips, and news! Get one of our [Godot game creation courses](https://gdquest.mavenseed.com/courses) to support our work on Free Software.

## Project Goal

The goal of this project is to provide the gamedev community with a demo that shows how game systems work together in a complete 2D Godot game demo.

The demo draws inspiration from RPG Maker and older JRPGs like Final Fantasy or Dragon Quest as well as the Godot 3 OpenRPG.

Throughout the project, heavy emphasis is to be placed on code that is...

- Updated to take advantage of what GDScript 4 has to offer.
- Simple, to best serve as a starting point for those diving into the project.
- Made to conform to GDQuest's [GDScript guidelines](https://gdquest.gitbook.io/gdquests-guidelines/godot-gdscript-guidelines).

## Our Mission

Together, we're creating a codebase and tools to show you some of the best practices to create:

- Turn-based games
- A combat system
- An inventory system
- Character progression
- User interface with multiple menus

And more! Do you want to contribute and improve your programming skills with Godot? Check out the open issues, suggest improvements and report bugs by opening new ones, and be sure to check the contributing guidelines below.

## Contributing Guidelines

All contributors are welcome 🙂. To ensure a smooth and a productive experience for everyone working together, we came up with some guidelines we all follow here.

Check our [Contributors Guide](https://gdquest.gitbook.io/gdquests-guidelines/contributing-to-gdquest-projects/) for more information 😄
